unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, shellapi, ExtCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Image3: TImage;
    Image1: TImage;
    Image2: TImage;
    Label6: TLabel;
    procedure Image3Click(Sender: TObject);
    procedure Image1Click(Sender: TObject);
    procedure Image2Click(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure Label6Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;
  change:integer;
const
  kSC_DragMove = $F012;

implementation

{$R *.dfm}

{

Exemple d'utilisation des rgions
Avec imagination on obtient de jolie design

DevelOpeR13
http://dev-zone.com/

}

procedure TForm1.Image3Click(Sender: TObject);
begin
 close;
end;

procedure TForm1.Image1Click(Sender: TObject);
begin
 Shellexecute(0, 'open', 'iexplore', 'http://dev-zone.com/contact.php', nil, SW_SHOWMAXIMIZED);
end;

procedure TForm1.Image2Click(Sender: TObject);
begin
 Shellexecute(0, 'open', 'iexplore', 'http://dev-zone.com/', nil, SW_SHOWMAXIMIZED);
end;

procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 ReleaseCapture();
 Perform(WM_SYSCOMMAND, kSC_DragMove, 0); // this moves the panel
end;


procedure TForm1.FormCreate(Sender: TObject);
const W=36*pi/180;
var R,R1,R2: HRgn; X,Y,i:integer;
 function S(a:integer;R:integer):integer;
 begin
   Result:=round(R*sin(W*a));
 end;
 function C(a:integer;R:integer):integer;
 begin
   Result:=round(R*cos(W*a));
 end;
 function GetStarReg(X,Y,R:integer):HRGN;
 var  P : array [0..4] of TPoint;
 begin
    P[0] := Point(X, Y-R);
    P[1] := Point(X-S(4,R), Y-C(4,R));
    P[2] := Point(X-S(8,R), Y-C(8,R));
    P[3] := Point(X-S(2,R), Y-C(2,R));
    P[4] := Point(X-S(6,R), Y-C(6,R));
    // polygone
    Result := CreatePolygonRgn(P, 5, WINDING);
 end;
begin

 change:=1100;

 height:=640;
 width:=870;
 X:=Width div 2;
 Y:=Height div 2;
 R:=GetStarReg(X,Y,450);
 i:=1;
 repeat
   R1:=GetStarReg(X-S(i,120),Y-C(i,change),25);
   CombineRgn(R,R,R1,RGN_OR);
   inc(i,2);
 until i>9;
 R1:=GetStarReg(X,Y,30);
 CombineRgn(R,R,R1,RGN_DIFF);
 R1:=CreateEllipticRgn(3,3,Width-6,Height-6);
 R2:=CreateEllipticRgn(100,100,Width-20,Height-10);
 CombineRgn(R1,R1,R2,RGN_DIFF);
 CombineRgn(R,R,R1,RGN_OR);
 SetWindowRgn(Handle, R, True);
end;

{ - - ici c'est le mme code, seul la valeur de (change:integer) a change - - }
procedure TForm1.Label6Click(Sender: TObject);
const W=36*pi/180;
var R,R1,R2: HRgn; X,Y,i:integer;
 function S(a:integer;R:integer):integer;
 begin
   Result:=round(R*sin(W*a));
 end;
 function C(a:integer;R:integer):integer;
 begin
   Result:=round(R*cos(W*a));
 end;
 function GetStarReg(X,Y,R:integer):HRGN;
 var  P : array [0..4] of TPoint;
 begin
    P[0] := Point(X, Y-R);
    P[1] := Point(X-S(4,R), Y-C(4,R));
    P[2] := Point(X-S(8,R), Y-C(8,R));
    P[3] := Point(X-S(2,R), Y-C(2,R));
    P[4] := Point(X-S(6,R), Y-C(6,R));
    // polygone
    Result := CreatePolygonRgn(P, 5, WINDING);
 end;
begin

 change:=1100;

 height:=640;
 width:=870;
 X:=Width div 2;
 Y:=Height div 2;
 R:=GetStarReg(X,Y,change);
 i:=1;
 repeat
   R1:=GetStarReg(X-S(i,120),Y-C(i,1100),25);
   CombineRgn(R,R,R1,RGN_OR);
   inc(i,2);
 until i>9;
 R1:=GetStarReg(X,Y,30);
 CombineRgn(R,R,R1,RGN_DIFF);
 R1:=CreateEllipticRgn(3,3,Width-6,Height-6);
 R2:=CreateEllipticRgn(100,100,Width-20,Height-10);
 CombineRgn(R1,R1,R2,RGN_DIFF);
 CombineRgn(R,R,R1,RGN_OR);
 SetWindowRgn(Handle, R, True);
end;

end.
